<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               v-model:search="search"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   @click="handleDelete">删 除
        </el-button>
        <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="small"
            @click="handleClean"
        >清空</el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove, cleanJobLog} from "@/api/quartz/joblog";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        search: {
          jobName: "sss",
          jobGroup: ""
        },
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "任务名称",
              prop: "jobName",
              search: true,
              rules: [{
                required: true,
                message: "请输入任务名称",
                trigger: "blur"
              }]
            },
            {
              label: "任务组名",
              prop: "jobGroup",
              type: "select",
              search: true,
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=task_group_name",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
            },
            {
              label: "调用方法",
              prop: "invokeTarget",
              rules: [{
                required: true,
                message: "请输入调用目标字符串",
                trigger: "blur"
              }]
            },
            {
              label: "日志信息",
              prop: "jobMessage",
              rules: [{
                required: true,
                message: "请输入日志信息",
                trigger: "blur"
              }]
            },
            {
              label: "执行状态",
              prop: "status",
              type: "select",
              search: true,
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=task_process_state",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
            },
            {
              label: "执行时间",
              prop: "createTime",
            },
            {
              label: "异常信息",
              prop: "exceptionInfo",
              type: "textarea",
              hide: true,
              span: 24
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.joblog_add, false),
          viewBtn: this.vaildData(this.permission.joblog_view, false),
          delBtn: this.vaildData(this.permission.joblog_delete, false),
          editBtn: this.vaildData(this.permission.joblog_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    created() {
      const queryParam = this.$route.query;
      console.log("queryParam -> ", queryParam);
      const jobId = queryParam.jobId;
      if (jobId !== undefined && jobId != 0) {
          this.search.jobName = queryParam.jobName;
          this.search.jobGroup = queryParam.jobGroup;
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        console.log("query -> ", this.query);
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      },
      /** 清空按钮操作 */
      handleClean() {
        this.$confirm('是否确认清空所有调度日志数据项？').then(function() {
          return cleanJobLog();
        }).then(() => {
          this.onLoad(this.page, this.query);
          this.$message({
            type: "success",
            message: "清空成功!"
          });
        }).catch(() => {});
      },
    }
  };
</script>

<style>
</style>
